#include "animatedimage.h"

#include <assert.h>

AnimatedImage::AnimatedImage(std::string filename, int frames, int updatesPerFrame, int x, int y) : Image(filename, x, y)
{
     assert(updatesPerFrame > 0);
     assert(frames > 0);
     
     AnimatedImage::frames = frames;
     AnimatedImage::updatesPerFrame = updatesPerFrame;
     
     AnimatedImage::frame = 0;
     AnimatedImage::updatesLeftOnFrame = updatesPerFrame;
     
     AnimatedImage::w(AnimatedImage::w() / frames);
     AnimatedImage::image_rect.w = AnimatedImage::image_rect.w / frames;
}

AnimatedImage::~AnimatedImage()
{

}

void AnimatedImage::update()
{
     if(AnimatedImage::updatesLeftOnFrame == 0)
     {
          AnimatedImage::updatesLeftOnFrame = AnimatedImage::updatesPerFrame;
          AnimatedImage::frame++;
          if(AnimatedImage::frame == AnimatedImage::frames)
               AnimatedImage::frame = 0;
          AnimatedImage::image_rect.x = AnimatedImage::image_rect.w * AnimatedImage::frame;
     }else{
          --AnimatedImage::updatesLeftOnFrame;
     }  
}
