#include "circlingimage.h"

#include <cmath>

CirclingImage::CirclingImage(std::string filename, int x, int y) : Image(filename, x, y)
{
     this->xStart = x;
     this->yStart = y;
     this->dAngle = 0;
     this->cAngle = 0;
     this->xCenter = x;
     this->yCenter = y;
}

CirclingImage::~CirclingImage()
{

}

void CirclingImage::setCircleParameters(double radius, double speed)
{
     this->radius = radius;
     this->dAngle = speed;
     this->cAngle = 0;
}

void CirclingImage::setCircleCenter(int x, int y)
{
     this->xCenter = x;
     this->yCenter = y;
}

void CirclingImage::update()
{
     this->cAngle += this->dAngle;
     this->xMidpoint(std::cos(this->cAngle) * this->radius + this->xCenter);
     this->yMidpoint(std::sin(this->cAngle) * this->radius + this->yCenter);
}
