#include "fadeoutscreen.h"

#include <assert.h>

FadeOutScreen::FadeOutScreen(int msToRun)
{
     this->msToRun = msToRun;
}

FadeOutScreen::~FadeOutScreen()
{

}

Screen::Result FadeOutScreen::runScreen()
{
     SDL_Surface* screen = SDL_GetVideoSurface();
     const int ticksPerFrame = 1000/40;

/*F*/SDL_Surface* fadeSurface = SDL_CreateRGBSurface(0, screen->w, screen->h, 32, 0xFF000000, 0x00FF0000, 0x0000FF00, 0x000000FF);
/*F*/SDL_FillRect(fadeSurface, NULL, 0x0000000F);
     
     int framesToRun = this->msToRun / ticksPerFrame;
     assert(framesToRun >= 0);
     while(framesToRun != 0)
     {
          Uint32 ticksAtLoopStart = SDL_GetTicks();
          
/*F*/     SDL_BlitSurface(fadeSurface, NULL, screen, NULL);
          SDL_Flip(screen);
          
          int time_to_wait = ticksPerFrame - (SDL_GetTicks() - ticksAtLoopStart);
          if(time_to_wait > 0)
               SDL_Delay(time_to_wait);
          --framesToRun;
     }
     
/*F*/SDL_FreeSurface(fadeSurface);
     
     return Screen::None;
}
