#include "image.h"

#include <iostream>
#include <assert.h>

Image::Image(std::string filename, int x, int y) : Area(x, y, 0, 0)
{
     source_filename = filename;
     
/*L*/SDL_Surface *temp = SDL_LoadBMP(filename.c_str());
/*L*/if (temp == NULL)
/*L*/{
/*L*/     std::cout << "Unable to load bitmap from " << filename << ". Reason: " << SDL_GetError() << std::endl;
/*L*/     exit(1);
/*L*/}
/*L*/image = SDL_DisplayFormat(temp);
/*L*/SDL_FreeSurface(temp);

/*C*/Uint32 colorkey = SDL_MapRGB(image->format, 255, 0, 255);
/*C*/SDL_SetColorKey(image, SDL_SRCCOLORKEY|SDL_RLEACCEL, colorkey);

     image_rect.x = 0;
     image_rect.y = 0;
     image_rect.w = image->w;
     image_rect.h = image->h;

     w(image->w);
     h(image->h);
     
     visible = true;
     
     std::cout << "Image from " << source_filename << " Created" << std::endl;
}

Image::~Image()
{
     assert(image != NULL);
     std::cout << "Image from " << source_filename << " Destroyed" << std::endl;
     SDL_FreeSurface(image);
     image = NULL;
}

void Image::update()
{

}

void Image::draw(SDL_Surface *screen)
{
     if(visible)
/*B*/     SDL_BlitSurface(image, &image_rect, screen, &rect);
}

bool Image::getVisible()
{
     return visible;
}

void Image::setVisible(bool vis)
{
     visible = vis;
}
