#include "SDL/SDL.h"

#include "gamescreen.h"
#include "fadeoutscreen.h"
#include <iostream>
#include <string>
#include <stdlib.h>
#include <time.h>

using namespace std;

int main(int argc, char *argv[])
{
     srand(time(NULL));

     if (SDL_Init(SDL_INIT_VIDEO) != 0) {
          std::cout << "Unable to initialize SDL: " << SDL_GetError() << std::endl;
          return 1;
     }

     atexit(SDL_Quit);

     SDL_Surface *screen = SDL_SetVideoMode(320, 240, 32, SDL_DOUBLEBUF);
     if (screen == NULL) {
          std::cout << "Unable to set video mode: " << SDL_GetError() << std::endl;
          return 1;
     }

     Screen* game = new GameScreen();
     switch(game->runScreen())
     {
     case Screen::Exit:
          std::cout << "You exited the game!" << std::endl;
          delete game;
          return 0;
          break;
     case Screen::Victory:
          std::cout << "You got all the gold!" << std::endl;
          break;
     case Screen::Defeat:
          std::cout << "You were eaten by a gure!" << std::endl;
          break;
     }
     delete game;
     
     game = new FadeOutScreen(1000);
     game->runScreen();
     delete game;

     return 0;
}
